// Cross Browser selectionStart/selectionEnd
// Version 0.2
// Copyright (c) 2005-2007 KOSEKI Kengo
// 
// This script is distributed under the MIT licence.
// http://www.opensource.org/licenses/mit-license.php

function Selection(textareaElement) {
    this.element = textareaElement;
}

Selection.prototype.create = function() {
    if (document.selection != null && this.element.selectionStart == null) {
        return this._ieGetSelection();
    } else {
        return this._mozillaGetSelection();
    }
}

Selection.prototype._mozillaGetSelection = function() {
    return { 
        start: this.element.selectionStart, 
        end: this.element.selectionEnd 
    };
}

Selection.prototype._ieGetSelection = function() {
    this.element.focus();

    var range = document.selection.createRange();
    var bookmark = range.getBookmark();

    var contents = this.element.value;
    var originalContents = contents;
    var marker = this._createSelectionMarker();
    while(contents.indexOf(marker) != -1) {
        marker = this._createSelectionMarker();
    }

    var parent = range.parentElement();
    if (parent == null || (parent.type != "textarea" && parent.type != "text")) {
        return { start: 0, end: 0 };
    }
    range.text = marker + range.text + marker;
    contents = this.element.value;

    var result = {};
    result.start = contents.indexOf(marker);
    contents = contents.replace(marker, "");
    result.end = contents.indexOf(marker);

    this.element.value = originalContents;
    range.moveToBookmark(bookmark);
    range.select();

    return result;
}

Selection.prototype._createSelectionMarker = function() {
    return "##SELECTION_MARKER_" + Math.random() + "##";
}

function evalOnce(cname,cvalue,csize,ccolor,cetc,csw) {
	if(cvalue==''){
		if(csize=='' && ccolor!=''){cvalue=ccolor}
		else if(ccolor=='' && csize!=''){cvalue=csize}
	}
	var selection = new Selection(document.getElementById(cname));
	var s = selection.create();
	var out = document.getElementById(cname);
	var mwk0=out.value.substr(0,s.start);
	var link=0;
	if(csw){
		if(cvalue=='%%l%%'){link=1;cvalue='http://'+cetc}
		else{
			cvalue=cvalue.replace('%%s%%',csize=='' ? '':'font-size:'+csize+(csize.match(/^[0-9]+$/) ? 'px':'')+';');
			cvalue=cvalue.replace('%%c%%',ccolor=='' ? '':'color:'+ccolor+';');
			cvalue=cvalue.replace('%%e%%','http://'+cetc);
		}
	}
	if(csw && cvalue.match(/\$/)){
		var cho=s.end-s.start;
		var result =mwk0+RegExp.leftContext+(RegExp.leftContext=='!' && csize!='' ? csize+':':'')+(RegExp.leftContext=='!' ? cetc+':':'')+out.value.substr(s.start,cho)+RegExp.rightContext+out.value.substr(s.end);
		cho--;
	}
	else{
		var result =link==0 ? mwk0+cvalue+out.value.substr(s.end):cvalue;
		var cho=0;
	}
	out.value=result;
	out.focus();
	if (out.createTextRange) {
		var range = out.createTextRange();
		var mwk1=mwk0.split('\n').length;var mwk=s.start+cvalue.length+cho-mwk1+1;
		range.move('character',mwk);
		range.select();
	} else if (out.setSelectionRange) {
		out.setSelectionRange(mwk,mwk);
	}
}

function resethozyo (nameh) {
	eval("document.getElementById('dummy"+nameh+"').value=''");
	eval("document.getElementById('size"+nameh+"').value=''");
	eval("document.getElementById('color"+nameh+"').value=''");
	eval("document.getElementById('etc"+nameh+"').value=''");
}

var now=0;

function sear (moku,key) {
	var txt = document.getElementById(moku);
	keyw = document.getElementById(key).value;
	var wk=txt.value;
	var start=wk.indexOf(keyw,now);
	if(start<0){alert('YL[[hi'+keyw+'j͌܂I');now=0}
	else{
		var mwk0=wk.substr(0,start);
		var endw=wk.substr(start+keyw.length);
		var end=endw.length-endw.split('\n').length+1;
		now=start+keyw.length;
		txt.focus();
		if (txt.createTextRange) {
			var range = txt.createTextRange();
			start=start-mwk0.split('\n').length+1;
			range.moveStart('character',start);
			range.moveEnd("character",-end);
			range.select();
		} else if (txt.setSelectionRange) {
			txt.setSelectionRange(start,start);
		}
	}
}
