#!/usr/bin/perl
# Copyright Shigeru Uchida 2010/06/10
$|=1;

## ------ Yahoo マップを使う場合の指定 -----------------
# Usage
# 引数は URLエンコード が必要 
# gmap.cgi?緯度,経度+吹き出しに表示するテキスト（address はアドレス）+地図横縦サイズ（640x480）+縮小率+アイコン画像+アイコン画像横縦サイズ（20x20）+key:アプリケーションID
# 不要な引数や、このCGI内で指定しているオプションは省略できます 
# オリジナルアイコンを引数で指定することができます 例：+/img/icon.gif+20x20
# 緯度,経度は必ず１番目の引数で指定してください
# アプリケーションIDを指定 
$yahoo_key='alve_api';
# 地図表示の縮小レベル 1～11 で指定 
$range_y=2;
# $yahoo=1;または引数で gmap.cgi?緯度,経度+yahoo+～ 
$yahoo=0;
# ホイール操作を無効 false 有効 true
$Wheel='false';
## ------------------------------------------------------

## ------ Google マップを使う場合の指定 -----------------
# Usage
# 引数は URLエンコード が必要 
# gmap.cgi?アドレス（または緯度,経度)+吹き出しに表示するテキスト（address はアドレス）+地図横縦サイズ（640x480）+縮小率
# 日本語MAPに限定する時は +ja 英語表記にする時は +en
# 不要な引数や、このCGI内で指定しているオプションは省略できます 
# アドレス（または緯度,経度)は必ず１番目の引数で指定してください
# 地図表示の縮小レベル 1～20 で指定,数値が大きいほど詳細な地図,小さくなると概要地図
$range=15;
# オリジナルアイコンを引数で指定できません、以下で指定します 例： 
# アイコン画像のURL
$g_icon='';
# ダブルクリックズームを使用 =1; 使用しない =0;
$DoubleClickZoom=0;
# スケールコントロールを表示 =1; 表示しない =0;
$scaleControl=1;
# マウススクロールで拡大、縮小を使用 =1; 使用しない =0;
$scrollwheel=0;
# ストリートビューを使用 =1; 使用しない =0;
$ViewControl=1;
# 吹き出しテキストを最初から表示 =1; 表示しない =0;
$fuki_disp=0;
# 吹き出しに適用するスタイルシート 
$info_st='font-size:13px; color:#666666';
## ------------------------------------------------------

## ------ Google , Yahoo 共通の指定 -----------------
# 地図を表示する縦横の大きさ（ピクセル） 
$width='596px';
$height='596px';
# マージン
$margin=1;
# 地図ボーダー表示
$border='1px solid gray';
# タイトル
$title='マップ';
# 住所がなかった時に表示する内容 例：$no_address='<img src="no-image_s.gif" width="299" height="199">';
$no_address='地図表示';
## ------------------------------------------------------

if(!$yahoo){
	if(eval 'use Jcode; 1'){$Jc=1}
	elsif(eval 'use Unicode::Japanese; 1'){$Jc=2}
}

$i=0;
foreach $data (split(/\+/,$ENV{'QUERY_STRING'})){
	$data=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	if($i++==0){$address=$data}
	else{
		if($data eq 'yahoo'){$yahoo=1;next}
		elsif($data eq 'nst'){$ViewControl=0;next}
		elsif($data=~/^(\d+)(x?)(\d*)/){
			if("$2$3" eq '' && $1>0 && $1<21){$range_h=$1}
			elsif($2){
				if($1<100 || $3<100){$icon_size=",{width:$1,height:".($3 eq '' ? $1:$3)}
				else{
					$width=$width1=$1;$height=$height1=$3;
					if($width!~/[a-z]/){$width.='px'}
					if($height!~/[a-z]/){$height.='px'}
				}
			}
		}
		elsif($data=~/\.(gif|jpg|png)$/ || $data=~/^[LS]\d$/){$icon=$data}
		elsif($data=~/^key:/){$key_h=$'}
		elsif($data=~/^dx:([\d\-]+)$/){$dx=$1}
		elsif($data=~/^dy:([\d\-]+)$/){$dy=$1}
		elsif($data eq 'i'){$mobile=1}
		elsif($data eq 'en' || $data eq 'jp'){$lang=$data}
		else{
			$fuki_text=$data;
			&kjc_conv(\$fuki_text,$hkjcode);
		}
	}
}
if($address eq ''){$noadd=1}
elsif($address=~/^[\d\.\, ]+$/){
	$address=~s/ //g;
	$ido_sw=1;
	if($address=~/^(\d+)\./){
		if((length($1)>2 && !$yahoo) || (length($1)>2 && $yahoo)){
			@data=split(',',$address);
			$address="$data[1],$data[0]";
		}
	}
}
else{
	if(length($address)<9){$noadd=1}
	else{
		if($Jc==1){($hkjcode,$nmatch)=Jcode::getcode($address)}
		elsif($Jc==2){$hkjcode=Unicode::Japanese->getcode($address)=~/(sjis|euc|jis|utf8)/ ? $1:''}
		&kjc_conv(\$address,$hkjcode);
		$Gaddress=~s/([^\w ])/'%'.unpack('H2', $1)/eg;
		$Gaddress=~tr/ /+/;
#		if(($blk=index($address,'　'))>=0){substr($address,$blk)=''}
#		$address=~s/ .*$//;
	}
}
if(defined $icon_size){
	$icon_size.=(defined $dx ? ",dx:$dx":'').(defined $dy ? ",dy:$dy":'').'}';
}
if($i==0){$noadd=1}
if(!defined $range_h){$range_h=$ido_sw && $yahoo ? $range_y:$range}
print "Content-type: text/html\n\n";
if(defined $mobile){
	print '<html><head><meta http-equiv="content-type" content="text/html; charset=shift_jis"><title>Map</title></head><body><img src="http://maps.google.com/maps/api/staticmap?center='."$address&markers=$address|color:red&zoom=".($range_h ? $range_h:'16')."&size=${width1}x${height1}&maptype=mobile&sensor=false",($lang ? "&language=$lang":''),"\" width=\"$width1\" height=\"$height1\"><br>";
	for(my $iG=$range_h-3;$iG<$range_h+4;$iG++){
		if($bb++>100){last}
		if($iG==$range_h){$wk.="\x8f\x6b\x8e\xda|"}
		else{
			if($iG>0 && $iG<21){$wk.="<a href=\"gmap.cgi?$address+${width1}x$height1+$iG+i".($lang ? "+$lang":'')."\">".($iG<$range_h ? '&lt;' x ($range_h-$iG):'&lt;' x ($iG-$range_h)).'</a>|'}
		}
	}
	chop($wk);
	print "$wk</bpdy></html>\n";
	exit;
}
print <<END1;
<!DOCTYPE html
 PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>$title</title>
<style type="text/css">
div.map {
	width: $width;
	height: $height;
	margin: ${margin}px auto;
	border: $border;
	text-align: center;
}
</style>
END1
if(defined $noadd){
print <<END2;
</head>
<body style="margin:0px">
<div id="map" class="map">$no_address</div>
</body>
</html>
END2
exit;
}
if($yahoo && $ido_sw){
	if(defined $key_h){$yahoo_key=$key_h}
	print '<script type="text/javascript" src="http://map.yahooapis.jp/MapsService/js/V2/?appid=',$yahoo_key,'"></script>',"\n";
	print '<script type="text/javascript">',"\n";
	print "\twindow.onload=function(){\n";
	print "\t\tvar icons = new YLLPoint($address);\n";
	print "\t\t_map=new YahooMapsCtrl('map',icons,$range_h,YMapMode.Map,YDatumType.WGS84);\n";
	if($icon){
		print "\t\t_map.addCategory('Map','$icon'$icon_size);\n";
		print "\t\t_map.addIcon('maps',icons,'','Map','$fuki_text');\n";
		print "\t\t_map.setVisibleCentermark(false);\n";
	}
	print "\t\t_map.setEnableWheelOperation($Wheel);\n";
	print "\t}\n";
	print "</script>\n";
	print "</head>\n<body style=\"margin:0px\">\n<div id=\"map\" class=\"map\"></div>\n</body>\n</html>\n";
	exit;
}
# ------ Google ----------
if(defined $fuki_text && $fuki_text eq 'address' && !$ido_sw){$fuki_text=$address}
print '<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false',($lang ? "&language=$lang":''),'"></script>',"\n";
print '<script type="text/javascript">',"\n";
print '//<![CDATA[',"\n";
print "\tfunction loadMap() {\n";
print "\t\tvar myOptions = {\n";
$wk='';
$wk.="\t\t\tzoom: $range_h,\n";
$wk.="\t\t\tmapTypeId: google.maps.MapTypeId.ROADMAP,\n";
if(!$DoubleClickZoom){$wk.="\t\t\tdisableDoubleClickZoom : false,\n"}
if($scaleControl){$wk.="\t\t\tscaleControl: true,\n"}
if(!$scrollwheel){$wk.="\t\t\tscrollwheel: false,\n"}
if($ViewControl){$wk.="\t\t\tstreetViewControl: true,\n"}
$wk=~s/,\n$/\n/;
print $wk;
print "\t\t}\n";
print "\t\tvar map = new google.maps.Map(document.getElementById('map'), myOptions);\n";
if(defined $fuki_text){
	print "\t\tvar infowindow = new google.maps.InfoWindow({\n";
	print "\t\t\tcontent: '<span style=\"$info_st\">$fuki_text</span>',\n";
	print "\t\t\tsize: new google.maps.Size(150,150)\n";
	print "\t\t});\n";
}
if($ido_sw){
	print "\t\tvar latlang=new google.maps.LatLng($address);\n";
	print "\t\tmap.setCenter(latlang);\n";
	print "\t\tvar marker = new google.maps.Marker({\n";
	$wk='';
	$wk.="\t\t\tmap: map,\n";
	$wk.="\t\t\tposition: latlang,\n";
	if($g_icon){$wk.="\t\t\ticon: '$g_icon',\n"}
	if($fuki_text ne ''){$wk.="\t\t\ttitle: '$fuki_text',\n"}
	$wk=~s/,\n$/\n/;
	print $wk;
	print "\t\t});\n";
	if($fuki_text ne ''){
		print "\t\tgoogle.maps.event.addListener(marker, 'click', function() {infowindow.open(map,marker)});\n";
		if($fuki_disp){print "\t\tinfowindow.open(map,marker);\n"}
	}
}
else{
	print "\t\tvar geocoder = new google.maps.Geocoder();\n";
	print "\t\tif(geocoder){\n";
	print "\t\t\tgeocoder.geocode( { 'address': '$address'}, function(results, status) {\n";
	print "\t\t\t\tif (status == google.maps.GeocoderStatus.OK) {\n";
	print "\t\t\t\t\tvar latlang=results[0].geometry.location;\n";
	print "\t\t\t\t\tmap.setCenter(latlang);\n";
	print "\t\t\t\t\tvar marker = new google.maps.Marker({\n";
	$wk='';
	$wk.="\t\t\t\t\t\tmap: map,\n";
	$wk.="\t\t\t\t\t\tposition: latlang,\n";
	if($g_icon){$wk.="\t\t\t\t\t\ticon: '$g_icon',\n"}
	if($fuki_text ne ''){$wk.="\t\t\t\t\t\ttitle: '$fuki_text',\n"}
	$wk=~s/,\n$/\n/;
	print $wk;
	print "\t\t\t\t\t});\n";
	if($fuki_text ne ''){
		print "\t\t\t\t\tgoogle.maps.event.addListener(marker, 'click', function() {infowindow.open(map,marker)});\n";
		if($fuki_disp){print "\t\t\t\t\tinfowindow.open(map,marker);\n"}
	}
	print "\t\t\t\t} else {alert('Geocode was not successful for the following reason: ' + status)}\n";
	print "\t\t\t});\n";
	print "\t\t}\n";
}
print "\t}\n";
print <<END7;
//]]>
</script>
</head>
<body style="margin:0px" onload="loadMap()">
<div id="map" class="map"></div>
</body>
</html>
END7
exit;

sub kjc_conv {
	local(*ksou)=@_;
	if($hkjcode ne '' && $hkjcode ne 'utf8'){
		if($Jc==2){$ksou=Unicode::Japanese->new($ksou,$hkjcode)->conv('utf8')}
		else{$ksou=Jcode::convert($ksou,'utf8',$hkjcode)}
	}
}
